#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <com_sobot_chat_utils_SobotUtil.h>
#include <md5.h>

const char *KEY = "sobot*&^%$#@!";

char *jstringToChar(JNIEnv *env, jstring jstr) {
    char *rtn = NULL;
    jclass clsstring = (*env)->FindClass(env, "java/lang/String");
    jstring strencode = (*env)->NewStringUTF(env, "utf-8");
    jmethodID mid = (*env)->GetMethodID(env, clsstring, "getBytes", "(Ljava/lang/String;)[B");
    jbyteArray barr = (jbyteArray) (*env)->CallObjectMethod(env, jstr, mid, strencode);
    jsize alen = (*env)->GetArrayLength(env, barr);
    jbyte *ba = (*env)->GetByteArrayElements(env, barr, JNI_FALSE);
    if (alen > 0) {
        rtn = (char *) malloc(alen + 1);
        memcpy(rtn, ba, alen);
        rtn[alen] = 0;
    }
    (*env)->ReleaseByteArrayElements(env, barr, ba, 0);
    return rtn;
}

JNIEXPORT jstring JNICALL Java_com_sobot_chat_utils_SobotUtil_getSign
  (JNIEnv *env, jclass j, jstring a, jstring b, jstring c, jstring d, jstring e){
    char *aa =jstringToChar(env,a);
    char *cc =jstringToChar(env,c);
    char *dd =jstringToChar(env,d);
    char *result = (char *) malloc(strlen(aa) + strlen(dd)+ strlen(cc)+ strlen(KEY));
    sprintf(result, "%s%s%s%s", aa,dd,cc,KEY);
    MD5_CTX context = { 0 };
    MD5Init(&context);
    MD5Update(&context, result, strlen(result));
    unsigned char dest[16] = { 0 };
    MD5Final(dest, &context);
    (*env)->ReleaseStringUTFChars(env, c, result);

    int i = 0;
    char szMd5[33] = { 0 };
    for (i = 0; i < 16; i++)
     {
          sprintf(szMd5, "%s%02x", szMd5, dest[i]);
     }
     return (*env)->NewStringUTF(env, szMd5);
}

